/* $Id: RubyScript.hh,v 1.15 2003/11/20 22:34:28 pervago Exp $ */

/**
 * @file   RubyScript.hh
 * @date   05-June-2003 10:49:54
 *
 * @brief Put brief explanation here
 *
 * Put a long explanation here.
 *
 */

/*
 * TODO
 * things need to be done with swig before this can be used
 */

#ifndef __RUBYSCRIPT_HH
# define __RUBYSCRIPT_HH

# include <ruby.h>
# undef PACKAGE
# undef PACKAGE_NAME
# undef PACKAGE_STRING
# undef PACKAGE_TARNAME
# undef PACKAGE_VERSION
# undef PACKAGE_BUGREPORT

# include "Types.hh"
# include "Script.hh"

class RubyScript : public Script {

public:

    // Create a RubyScript object from a file name.
    // @param filename The file name
    // @throw InvalidFileType if filename is not named as a python script
    RubyScript(const std::string &filename);

    // Create a RubyScript object by copying another.
    // @param that The RubyScript object to copy
    RubyScript(const RubyScript &that);

    // Destroy this object.
    virtual ~RubyScript();

    // Execute the ruby file represented by this Script.
    // @return true if executed successfully, false otherwise
    virtual bool run();

protected:

    // Function which can be passed to rb_protect to handle any exception raised by ruby_run(),
    // @return non-zero if an exception was raised, zero otherwise
    int protected_run(VALUE arg);

    // TODO provide some mechanism by which children can pass-down their
    // suffix list and augment ours? should we worry about children of
    // children of Script?

private:

    // Functions to initialize/finalize interpreter (only once)
    static void initialize();
    static void finalize();

    // Keep a running count of instances.
    static int _count;

    // static initialization hack
    static int _staticInit;
    static int doStaticInit();
};

#endif
